﻿/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.actionscript-facile.com
  Portions created by the Initial Developer are Copyright (C) 2010
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */
package
{
	import flash.filters.BitmapFilterQuality;
	import flash.filters.GlowFilter;
	import utils.BitmapText;


	import flash.text.Font;
	import flash.display.LoaderInfo;
	import flash.events.IOErrorEvent;
	import flash.net.URLRequest;
	import flash.display.Loader;
	import flash.text.TextFormat;
	import flash.text.TextField;
	
	
	import com.actionscriptfacile.ui.text.UITextField;
	
	
	import flash.events.Event;
	import flash.display.Sprite;
	
	
	import com.demonsters.debugger.MonsterDebugger;


	public class Main extends Sprite
	{
		private var oTxtInfo : UITextField;
		private var oBitmapText : BitmapText;
		private var iScore : int;
		private var oTextFieldOr : TextField;
		private var oFilter : GlowFilter;
		
		
		/**
		 * Constructeur.
		 * 
		 */
		public function Main()
		{
			// attend la fin de l'initialisation de la scène
			this.addEventListener(Event.ADDED_TO_STAGE, onReady, false, 0, true);
		}
		

		/**
		 * Démarrage de l'application.
		 * définit le nombre d'images par secondes dans les paramètres de compilation
		 * -default-frame-rate 40
		 * 
		 */
		private function onReady(event : Event) : void
		{
			this.removeEventListener(Event.ADDED_TO_STAGE, onReady);

			// Init De MonsterDebugger
			MonsterDebugger.initialize(this);
			MonsterDebugger.trace(this, "Start Application");
			
			//this.loadFont("http://www.actionscript-facile.com/ressources/swf/FontOnky.swf?nocache="+Math.random()*34);
			this.loadFont("FontOnky.swf?nocache="+Math.random()*34);
			
			this.setupUI();
		}


		/**
		 * Affiche les champs textes.
		 * 
		 */
		private function setupUI() : void
		{
			iScore = 0;
			
			oTxtInfo = this.addText("Chargement des polices de caractères...");
			oTxtInfo.x = 34;
			oTxtInfo.y = 10;
			this.addChild(oTxtInfo);	
			
			// création d'un filtre sur les champs textes
			oFilter = new GlowFilter(0x00C5DF,1.0,2.0,2.0,10);
			oFilter.quality = BitmapFilterQuality.MEDIUM;
		}
		
		
		/**
		 * Chargement d'un swf police de caractère pour le TextField.
		 * comparaison de la qualité avec Bitmap Texte.
		 *  
		 */
		private function loadFont(url : String) : void
		{
			MonsterDebugger.trace(this,"loadFont : "+url);
			var loader : Loader = new Loader();
			loader.contentLoaderInfo.addEventListener(Event.COMPLETE, onLoadComplete);
			loader.contentLoaderInfo.addEventListener(IOErrorEvent.IO_ERROR, onLoadError);
			loader.load( new URLRequest( url ) );
		}
		
		
		/**
		 * Appel chaque image par seconde.
		 * Mise à jour des champs textes.
		 * 
		 */
		private function onEnterFrame(event : Event) : void
		{
			iScore++;
			
			// ajoute des zeros avant le score
			var sTemp:String = iScore.toString();
			while (sTemp.length < 5)	sTemp = "0" + sTemp;
			
			oBitmapText.text = "Bitmap -   : "+sTemp;
			oTextFieldOr.text = "Original -  : "+sTemp;
		}
		
		
		/**
		 * Le swf de fonts est chargé.
		 * 
		 */
		private function onLoadComplete(event : Event) : void
		{
			MonsterDebugger.trace(this,"onLoadComplete");
			MonsterDebugger.trace(this,event);
			
			// créer une instance de la classe contenant les polices
			var FontLibrary:Class = event.target.applicationDomain.getDefinition("FontOnky") as Class;
            Font.registerFont(FontLibrary._Font);// enregistre une seule font
			
			MonsterDebugger.trace( this, Font.enumerateFonts() );
			
			oTxtInfo.text = "";
			
			// création d'un TextField dynamique
			oTextFieldOr = new TextField();
			oTextFieldOr.embedFonts = true;
			
			// applique la police chargée dynamiquement 
			var oTextFormat:TextFormat = new TextFormat();
			oTextFormat.font = "onkyItal";
			oTextFormat.size = 34;
			oTextFormat.color = 0x006f77;
			oTextFieldOr.defaultTextFormat = oTextFormat;
			
			oTextFieldOr.selectable = false;
			oTextFieldOr.x = 10;
			oTextFieldOr.y = 180;
			oTextFieldOr.width = 500;
			oTextFieldOr.text = "Original -    : 00000";
			oTextFieldOr.filters=[oFilter];// applique un filtre sur le texte
			this.addChild(oTextFieldOr);			
			
			// création du texte Bitmap
			var oTextField:TextField = new TextField();

			oTextField.embedFonts = true;
			oTextField.defaultTextFormat = oTextFormat;		
			oTextField.x = 10;
			oTextField.y = 230;
			oTextField.width = 500;
			oTextField.text = "Bitmap -   : 00000";
			oTextField.filters=[oFilter];// applique un filtre sur le texte
			this.addChild(oTextField);
			
			var pProperty:Object  = {margin:-5};// réduit l'espace entre les caractères
			
			// transforme le texte en images bitmap
			oBitmapText = new BitmapText(oTextField, null, null, pProperty);
			
			// mise à jour du texte tous les images par secondes
			this.addEventListener(Event.ENTER_FRAME, onEnterFrame);
			MonsterDebugger.trace(this,"finish");
		}
		
				
	
		
		/**
		 * Gestion des erreurs de chargement.
		 * 
		 */
		private function onLoadError(e:IOErrorEvent):void 
		{
			MonsterDebugger.trace(this,"erreur de chargement : " + e.text);
			MonsterDebugger.trace(this,e);
			
			var contentLoaderInfo:LoaderInfo = LoaderInfo( e.target);
			contentLoaderInfo.removeEventListener(Event.COMPLETE, onLoadComplete );
			contentLoaderInfo.removeEventListener(IOErrorEvent.IO_ERROR, onLoadError );
			
			
			var text:TextField = addChild( new TextField() ) as TextField;
			text.width = stage.stageWidth;
			text.autoSize = 'center';
			text.text = "Erreur de chargement : "+e.text;
		}
		
		/**
		 * Création d'un champ texte.
		 * 
		 */
		private function addText(sValue:String) : UITextField
		{
			var oTxtField:UITextField = new UITextField();
			oTxtField.text = sValue;
			oTxtField.selectable = false;
			oTxtField.autoSizeLeft();
			oTxtField.alignLeft(); // centre le texte
			oTxtField.changeFormat("size", 18);// changement de la taille de la police du texte
			oTxtField.changeFormat("font", "Arial");// changement de la taille de la police du texte
			oTxtField.changeFormat("color", 0x006f77);// changement de la couleur
			
			return oTxtField;	 
		}
		
	}
}
